-- Bug reports to:
--                  J-Man Th' Shaman [DiS]
--                  jshaman@phreak.org

-- If someone can instruct me on how to build a custom EGA/VGA character set
-- on the PC, it would be a faster implimentation than this. (Though CGA would
-- not be supported).  Please drop me a note.

-- The procedure cg_puts(i, s) will print a commodore64 character s with the
-- color i in the next character location in any of the supported graphics
-- modes.

-- Please note: the character s is not the ascii code but rather the rom
-- character number from 1-512.  The file romchar.dat is a snapshot of
-- the character images from $d000-$dfff on the US C-64.

-- Possible applications: c64 emulator and disk image tools.
--                        c64/cg terminal emulator.
-- 

-- This routine updates the screen character location also, so you can
-- concievably mix "PETSCII" and PC-ASCII on the screen easily.


include cgputs.e
include get.e
include graphics.e

sequence modes, s
integer x, c


modes = {4,5,6,13,14,15,16,17,18,19,256,257,258,259,260,261}
c = 0
for modex = 1 to length(modes) by 1 do
    x = graphics_mode(-1)
    -- some video cards have trouble going from some modes directly to another.
    x = graphics_mode(modes[modex])
    s = video_config()
    if x > -1 then
	for u = 0 to 1 by 1 do
	    clear_screen()
	    printf(1,"Mode %d: ",modes[modex])
	    if u=0 then 
		puts(1,"Uppercase/Graphics:\n")
	    else
		puts(1,"Lowercase:\n")
	    end if
	    for t = 1 to 256 by 1 do
		c = c + 1
		if c = s[7] then c = 1
		end if
		cg_puts(c,{t+u*256})
	    end for
	    puts(1,"\n\nPress any key.")
	    x = wait_key()
	    if x = 27 then
		x = graphics_mode(-1)
		clear_screen()
		abort(0)
	    end if
	end for
    end if
end for
x = graphics_mode(-1)
clear_screen()
